/* This is simple stuff - we just parse each one, and try to insert the
   data based on the offset of 
*/

#include <errno.h>
#include <stdio.h>
#include <string.h>
#include "bootmenu.h"

int parse_file(const char *file, struct keywords *keywords, void *data) {
    
  int ret = 0;
  
  FILE *stream = fopen(file, "r");
  if (!stream) {
    LOG("Unable to open file [%s] for reading [%s]\n", file, strerror(errno));
    return -1;
  }

  while(!feof(stream) && !ferror(stream)) {
    int i;
    char *ptr, buffer[128];

    if (!(ptr = fgets(buffer, sizeof(buffer), stream)))
      continue;

    ptr[strlen(buffer) - 1] = 0;

    for( ; *ptr && (*ptr == ' ' || *ptr == '\t'); ptr++);
    
    /* Skip over empty lines and commments */
    if (*ptr == '\0' || *ptr == '#') continue;
    
    /* Get the values for the keywords */

    for (i = 0; keywords[i].keyword != NULL; i++) {
      char **dest;

      if (strncmp(ptr, keywords[i].keyword, strlen(keywords[i].keyword)))
	continue;

      dest = (char **) (((char *) data) + keywords[i].offset);
      *dest = strdup(ptr + strlen(keywords[i].keyword));

      break;
    }
  }
  
  fclose(stream);
  return ret;
}
  
